﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        MyObject obj;

        public Form1()
        {
            InitializeComponent();
            obj = new MyObject ();
            obj.X = 7;
            obj.Text = "Abc";
            propertyGrid1.SelectedObject = obj;
        }

        private void testToolStripMenuItem_Click(object sender, EventArgs e)
        {
            listView1.ShowItemToolTips = true;

            ListViewItem item = new ListViewItem();
            item.Text = "Klm";
            item.ToolTipText = "Nápověda";
            item.SubItems.Add("sloupec 2");
            item.SubItems.Add("sloupec 3");
            listView1.Items.Add(item);
        }

        private void showControls(Control c)
        {
            foreach (Control s in c.Controls)
            {
                ListViewItem item = new ListViewItem();
                item.Text = s.Name;
                item.ToolTipText = s.GetType().ToString ();
                item.SubItems.Add(s.GetType().Name);
                item.SubItems.Add(s.GetType().ToString ());
                item.Tag = s;
                listView1.Items.Add(item);

                showControls(s);
            }
        }

        private void componentsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            showControls(this);
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count == 1)
                propertyGrid1.SelectedObject =
                              listView1.SelectedItems[0].Tag;
            else
                propertyGrid1.SelectedObject = null;
        }

        public void reflectionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            object p = this;
            System.Type t = p.GetType();
            System.Reflection.MethodInfo [] m = t.GetMethods();
            foreach (System.Reflection.MethodInfo n in m)
            {
                ListViewItem item = new ListViewItem();
                item.Text = n.Name;
                item.ToolTipText = n.ToString();
                item.SubItems.Add(n.ReturnType.Name);
                item.SubItems.Add(n.ToString());
                item.Tag = n;
                listView1.Items.Add(item);
            }
        }

    }
}
